  PROGRAM

  INCLUDE('WINSOCK.INC')
  INCLUDE('windows.inc')

  MAP
    MODULE('WinSSL.DLL')
      SSL_library_init(),LONG,RAW,PASCAL,NAME('SSL_library_init')
      SSL_CTX_new(LONG Method),LONG,RAW,PASCAL,NAME('SSL_CTX_new')
      SSLv23_client_method(),LONG,RAW,PASCAL,NAME('SSLv23_client_method')
      SSL_new(LONG),LONG,RAW,PASCAL,NAME('SSL_new')
      SSL_free(LONG SSL),RAW,PASCAL,NAME('SSL_free')
      SSL_set_fd(LONG SSL, LONG Sock),LONG,RAW,PASCAL,NAME('SSL_set_fd')
      SSL_connect(LONG SSL),LONG,RAW,PASCAL,NAME('SSL_connect')
      SSL_write(LONG SSL, LONG Buffer, LONG BufferSize),LONG,RAW,PASCAL,NAME('SSL_write')
      SSL_read(LONG SSL, LONG Buffer, LONG BufferSize),LONG,RAW,PASCAL,NAME('SSL_read')
      SSL_get_error(LONG SSL, LONG ret),LONG,RAW,PASCAL,NAME('SSL_get_error')
    END
  END


SSLClass                CLASS,TYPE
WSA                       LIKE(WSAData)
Sock                      SOCKET
SSL                       LONG
Init                      PROCEDURE
Init_Winsock              PROCEDURE(),LONG,PROC
Init_DLL                  PROCEDURE(),LONG
Connect                   PROCEDURE(STRING ServerIP, STRING PortNumber),LONG 
Kill                      PROCEDURE()
Send                      PROCEDURE(STRING Text) 
Read                      PROCEDURE(),STRING 
                        END

SL                      SSLClass

  CODE
  SL.Init()
  IF SL.Connect('5.255.255.55', 443)
    MESSAGE('Error on connect')
  END  
  SL.Send('GET / HTTP/1.0\r\nHost: forum.antichat.ru\r\n\r\n')
  MESSAGE(SL.Read())
  SL.Kill()
  !MESSAGE('End & unload')

SSLClass.Init           PROCEDURE
  CODE
  IF SELF.Init_Winsock()
    MESSAGE('Error on init Winsock')
    RETURN
  END
  SELF.SSL = SELF.Init_DLL()
  IF ~SELF.SSL
    MESSAGE('Error on init SSL')
    RETURN
  END
  !MESSAGE('SSL handle: ' & SELF.SSL)

SSLClass.Kill           PROCEDURE()  
  CODE
  IF SELF.SSL
    SSL_free(SELF.SSL)
  END

SSLClass.Send           PROCEDURE(STRING Text) 
LOC:buffer              CSTRING(2048)
  CODE 
  LOC:buffer = Text
  Err# = SSL_write(SELF.SSL,ADDRESS(LOC:buffer),SIZE(LOC:buffer))
  !MESSAGE('SSL_write: ' & Err# & '|GetLastError: ' & GetLastError())

SSLClass.Read           PROCEDURE()!,STRING 
LOC:buffer              CSTRING(2048)
  CODE 
  Err# = SSL_read(SELF.SSL,ADDRESS(LOC:buffer),SIZE(LOC:buffer))
  !MESSAGE('SSL_read: ' & Err#)
  RETURN LOC:buffer

SSLClass.Init_Winsock   PROCEDURE()
s                       SOCKET
wsaDataBlock            LIKE(WSAData)
  CODE
  s = WS_SOCKET(AF_INET, SOCK_STREAM, IPPROTO_TCP)
  IF s = SOCKET_ERROR
    IF WSAGetLastError() = WSANOTINITIALISED                ! Was it that the socket layer wasn't initialised?
      IF WSAStartup(s32_Version2_0, wsaDataBlock)         ! Tries to initialize it
        RETURN 1                                            ! If still an error, give up
      END
      s = WS_SOCKET(AF_INET, SOCK_STREAM, IPPROTO_TCP)
      IF s = SOCKET_ERROR THEN RETURN 1 END                 ! Still error, give up
    END
  END
  SELF.Sock = s
  RETURN 0

SSLClass.Init_DLL       PROCEDURE()    
Method                  LONG
SSL_CTX                 LONG
  CODE
  Ret# = SSL_library_init()
  IF Ret#
    Method = SSLv23_client_method()
    IF Method
      SSL_CTX = SSL_CTX_new(Method)
      IF SSL_CTX
        SSL_Ret# = SSL_new(SSL_CTX)  
        RETURN SSL_Ret#
      END
    END  
  END
  RETURN 0
  
SSLClass.Connect        PROCEDURE(STRING pServerIp, STRING pPortNumber)!,LONG   
szIP                    CSTRING(64)
inetAddr                ULONG
dest                    LIKE(SOCKADDR_IN)
ret                     LONG
  CODE
  szIP = pServerIp
  inetAddr = WS_INET_ADDR(szIP)
  IF inetAddr = INADDR_NONE OR inetAddr = INADDR_ANY
    MESSAGE('Can''t connect to "ANY" address')
    RETURN 1
  END
  dest.sin_family = AF_INET
  dest.sin_addr.s_un.s_addr = inetAddr
  dest.sin_port = WS_HTONS(pPortNumber)
  IF WS_CONNECT(SELF.Sock, ADDRESS(dest), SIZE(dest) ) = SOCKET_ERROR
    MESSAGE('Socket error')
    RETURN 2
  END
  IF ~SSL_set_fd(SELF.SSL, SELF.Sock)
    RETURN 3
  END
  ret = SSL_connect(SELF.SSL)
  IF ret <> 1
    MESSAGE(SSL_get_error(SELF.SSL, ret),'SSL_get_error')
  END
  RETURN 0